// IMPORTANT: Make sure to import `instrument.js` at the top of your file.
import "./instrument.js";

// All other imports below
import * as Sentry from "@sentry/node";
import express from "express";

const app = express();

app.get("/", function rootHandler(req, res) {
  // Start a transaction that will be profiled
  Sentry.startSpan(
    {
      name: "CPU Intensive Work",
    },
    async () => {
      // Add a child span for more granular profiling
      Sentry.startSpan(
        {
          name: "Random Number Generation",
          op: "math.random",
        },
        () => {
          for (let i = 0; i < 1000000; i++) {
            Math.random();
          }
        }
      );
    }
  );

  throw new Error("Error despite profiling imported!");
  res.end("Hello world!");
});

// The error handler must be registered before any other error middleware and after all controllers
Sentry.setupExpressErrorHandler(app);

// Optional fallthrough error handler
app.use(function onError(err, req, res, next) {
  // The error id is attached to `res.sentry` to be returned
  // and optionally displayed to the user for support.
  res.statusCode = 500;
  res.end(res.sentry + "\n");
});

app.listen(3000);
